Attribute VB_Name = "Modul1"
Option Explicit

Type BrowseInfo
    hwndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long
End Type
    

Declare Function VarPtr Lib "vb40032.dll" (ByVal a As Any) As Long
Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Declare Function SHGetSpecialFolderLocation Lib "shell32" (ByVal hwndOwner As Long, ByVal nFolder As Integer, ppidl As Long) As Long
Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Declare Function SHFormatDrive Lib "shell32" (ByVal hwnd As Long, ByVal Drive As Long, ByVal fmtID As Long, ByVal options As Long) As Long
Declare Function GetDriveType Lib "Kernel32" Alias "GetDriveTypeA" (ByVal nDrive As String) As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByVal lpvParam As Any, ByVal fuWinIni As Long) As Long

Public Const SPIF_SENDWININICHANGE = &H2
Public Const SPI_SETSCREENSAVEACTIVE = 17

Public Const CSIDL_DESKTOP = &H1& 'Desktop
Public Const CSIDL_PROGRAMS = &H2& 'Unterverzeichnisse von 'Programme'
Public Const CSIDL_STARTMENU = &HB& 'Startmen
Public Const CSIDL_DRIVES = &H11& 'Arbeitsplatz
Public Const CSIDL_FAVORITES = &H6& 'Internet-Favoriten (Bookmarks)

Public Const BIF_RETURNONLYFSDIRS = 1

Public Const WM_SYSCOMMAND = &H112
Public Const SC_SCREENSAVE = &HF140

Sub FormatDrive(DriveLetter As String, Owner As Form)
Dim Number As Long
Number = Asc(DriveLetter) - 65
Call SHFormatDrive(Owner.hwnd, Number, 0&, 0&)
End Sub


Function SelectFolder95(StartFolderID As Long, UserMsg As String, Owner As Form) As String
'**************************************
'Diese Funktion knnen Sie direkt in Ihre Projekte bernehmen
'Es werden folgende Parameter erwartet:
'
'1. StartFolderID (Long) - Eine CSIDL_??? Konstante (in diesem Modul definiert)
'2. UserMsg (String) - Ein Hinweistext fr den Anwender (wird im Dialog angezeigt)
'3. Owner (Form) - Eine Referenz auf die aufrufende Form
'
'Rckgabewert (String): Das gewhlte Verzeichnis oder ein leerer String,
'wenn auf 'Abbrechen' geklickt wurde.
'************************************************************

Dim BInfo As BrowseInfo, BrowseRoot As Long
Dim pid As Long, SelPath As String

Call SHGetSpecialFolderLocation(Owner.hwnd, StartFolderID, BrowseRoot)

With BInfo
    .hwndOwner = Owner.hwnd
    .pIDLRoot = BrowseRoot
    'Man kann nur Verzeichnisse auswhlen, sonst ist der 'OK'-Button disabled
    .ulFlags = BIF_RETURNONLYFSDIRS
    .lpszTitle = VarPtr(UserMsg)
End With

pid = SHBrowseForFolder(BInfo)

If pid Then
    SelPath = Space$(255)
    Call SHGetPathFromIDList(pid, SelPath)
    SelPath = Left$(SelPath, InStr(SelPath, Chr$(0)) - 1)
Else
    SelPath = ""
End If
SelectFolder95 = SelPath
End Function

Sub StartSaver(Owner As Form)
Call SendMessage(Owner.hwnd, WM_SYSCOMMAND, SC_SCREENSAVE, 0&)
End Sub


